/* WARNING: THIS FILE IS AUTOMATICALLY GENERATED FROM A .SM FILE.
 * Changes made here will most likely be overwritten.
 */

/* 
 * (C) 2001 Clemson University and The University of Chicago 
 *
 * See COPYING in top-level directory.
 */
#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/time.h>

#include "client-state-machine.h"
#include "state-machine-fns.h"
#include "job-time-mgr.h"

extern job_context_id pint_client_sm_context;

static int job_timer_do_work(
    PINT_client_sm *sm_p, job_status_s* js_p);
static int job_timer_error(
    PINT_client_sm *sm_p, job_status_s* js_p);

extern union PINT_state_array_values ST_do_work[];
extern union PINT_state_array_values ST_error[];

struct PINT_state_machine_s pvfs2_client_job_timer_sm =
{
	ST_do_work,
	"pvfs2_client_job_timer_sm"
};
static union PINT_state_array_values ST_do_work[] = {
(union PINT_state_array_values) 0,
(union PINT_state_array_values) job_timer_do_work,
(union PINT_state_array_values) 0,
(union PINT_state_array_values) ST_do_work,
(union PINT_state_array_values) -1,
(union PINT_state_array_values) ST_error
};

static union PINT_state_array_values ST_error[] = {
(union PINT_state_array_values) 0,
(union PINT_state_array_values) job_timer_error,
(union PINT_state_array_values) -1,
(union PINT_state_array_values) 7
};

# 43 "src/client/sysint/client-job-timer.sm"


/* job_timer_error()
 *
 * cleans up any resources consumed by this state machine and ends
 * execution of the machine
 */
static int job_timer_error(PINT_client_sm *sm_p, job_status_s* js_p)
{
    gossip_debug(GOSSIP_CLIENT_DEBUG,
                 "job timer state: job_timer_error\n");
    gossip_err("Error: stopping client job timer.\n");

    sm_p->op_complete = 1;
    return 0;
}

/* job_timer_do_work()
 *
 * resets counters, updates metrices, etc- this is intended to be
 * called repeatedly on a regular interval
 */
static int job_timer_do_work(PINT_client_sm *sm_p, job_status_s* js_p)
{
    int ret = -1;
    job_id_t tmp_id;

#if 0
    gossip_debug(GOSSIP_CLIENT_DEBUG,
                 "job timer state: job_timer_do_work\n");
#endif

    /* look for expired jobs */
    ret = job_time_mgr_expire();
    if (ret < 0)
    {
        js_p->error_code = ret;
        return 1;
    }
        
    /* post another timer */
    return job_req_sched_post_timer(
        1000, sm_p, 0, js_p, &tmp_id, pint_client_sm_context);
}

/*
 * Local variables:
 *  mode: c
 *  c-indent-level: 4
 *  c-basic-offset: 4
 * End:
 *
 * vim: ft=c ts=8 sts=4 sw=4 expandtab
 */
