#ifndef I2C_ALGO_USB_H
#define I2C_ALGO_USB_H 1 

#include <linux/i2c.h>

struct i2c_algo_usb_data {
	void *data;		/* private data for lowlevel routines */
	int (*inb) (void *data, unsigned char addr, char *buf, short len);
	int (*outb) (void *data, unsigned char addr, char *buf, short len);

	/* local settings */
	int udelay;
	int mdelay;
	int timeout;
};

#define I2C_USB_ADAP_MAX	16

int i2c_usb_add_bus(struct i2c_adapter *);
int i2c_usb_del_bus(struct i2c_adapter *);

static inline void *i2c_get_algo_usb_data (struct i2c_algo_usb_data *dev)
{
	return dev->data;
}

static inline void i2c_set_algo_usb_data (struct i2c_algo_usb_data *dev, void *data)
{
	dev->data = data;
}

#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,0)
static inline void *i2c_get_clientdata (struct i2c_client *dev)
{
	return dev->data;
}

static inline void i2c_set_clientdata (struct i2c_client *dev, void *data)
{
	dev->data = data;
}

static inline void *i2c_get_adapdata (struct i2c_adapter *dev)
{
	return dev->data;
}

static inline void i2c_set_adapdata (struct i2c_adapter *dev, void *data)
{
	dev->data = data;
}
#endif

#endif //I2C_ALGO_USB_H
