#! /bin/sh

DEFTREE=~/kernel/linux-orinoco

usage () {
    echo "Usage: $0 [<driver-tree> [<kernel-tree>]]" >&2
    exit 1
}

if [ $# == 0 ]; then
    SRC=.
    TREE=$DEFTREE
elif [ $# == 1 ]; then
    SRC=$1
    TREE=$DEFTREE
elif [ $# == 2 ]; then
    SRC=$1
    TREE=$2
else
    usage
fi

if ! [ -d $SRC -a -f $SRC/README.orinoco ]; then
    usage
fi

if ! [ -d $TREE -a -f $TREE/CREDITS -a -d $TREE/drivers/net/wireless ]; then
    usage
fi

DIR=$TREE/drivers/net/wireless

rm -f $DIR/{hermes.[ch],hermes_rid.h,ieee802_11.h,orinoco.[ch],orinoco{_cs,_plx,_pci,_tmd}.c,airport.c}
cp $SRC/{hermes.[ch],hermes_rid.h,ieee802_11.h,orinoco.[ch],orinoco{_cs,_plx,_pci,_tmd}.c,airport.c} $DIR
