/*
 *  
 *  Copyright (C) 2004 Bell Kin bell_kin@pek.com.tw
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

#ifndef _ISL_AP_H
#define _ISL_AP_H

#include <linux/netdevice.h>

#define PRISM54_AP_ASSOC 0x1	/* include (de/re)associate packets */
#define PRISM54_AP_AUTH	 0x2	/* include (de/re)authenticate packets */
#define PRISM54_AP_PROB  0x4	/* include probe packets */
#define PRISM54_AP_BEAC  0x8	/* include beacon packets */
#define PRISM54_AP_AA    0x3	/* include a&a packets, default */

struct ap_net_frame_header {
	int op;
	unsigned long oid;
};

struct ap_net_local {
	struct net_device_stats stats;	/* tx/rx statistics */
	struct net_device *parent_dev;
};

int create_ap_dev(struct net_device *dev, char *aifname);
int destroy_ap_dev(struct net_device *dev);
int ap_net_open(struct net_device *dev);
int ap_net_send_packet(struct sk_buff *skb, struct net_device *dev);
int ap_net_rx_packet(struct sk_buff *skb, struct net_device *dev);
int ap_net_ioctl(struct net_device *dev, struct ifreq *ifr, int cmd);
struct net_device_stats *ap_net_get_stats(struct net_device *dev);
int ap_net_close(struct net_device *dev);

#endif				/* _ISL_AP_H */
