/***************************************************************************
 * Generic video post-processing functions for the W996[87]CF driver       *
 * for Linux.                                                              *
 *                                                                         *
 * Copyright (C) 2002-2005 by Luca Risolia <luca.risolia@studio.unibo.it>  *
 *                                                                         *
 * This program is free software; you can redistribute it and/or modify    *
 * it under the terms of the GNU General Public License as published by    *
 * the Free Software Foundation; either version 2 of the License, or       *
 * (at your option) any later version.                                     *
 *                                                                         *
 * This program is distributed in the hope that it will be useful,         *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of          *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           *
 * GNU General Public License for more details.                            *
 *                                                                         *
 * You should have received a copy of the GNU General Public License       *
 * along with this program; if not, write to the Free Software             *
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.               *
 ***************************************************************************/

#ifndef _W9968CF_VPPFUNCS_H_
#define _W9968CF_VPPFUNCS_H_

#include <asm/types.h>

extern inline void w9968cf_swap_yuvbytes(void* pIn, unsigned long length);
extern void w9968cf_scale_up(u8* pIn, u8* pOut, 
                             u16 w0, u16 h0, u16 bpp, u16 w1, u16 h1);
extern void w9968cf_uyvy_to_rgbx(u8* pIn, unsigned long length, u8* pOut,
                                 u16 out_fmt, u8 force_rgb);

#endif /* _W9968CF_VPPFUNCS_H */
